using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;

using System;
using System.Collections;

using System.Xml;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace sbrcli
{
	public abstract class BibleFormat
	{
        public const int F01_ZEFANIA_BIBLE = 1;
        public const int F02_UNBOUND_BIBLE_BCV = 2;
        public const int F03_UNBOUND_BIBLE_BCVS = 3;
        public const int F05_OSIS = 4;
        public const int F06_GBF = 5;
        public const int F07_XSEM = 6;
        public const int F08_THEWORD = 7;
        public const int F10_ESWORD_BBLX = 9;
        public const int F11_ESWORD_BBLI = 10;
        public const int F12_SWORDPROJECT = 11;
        public const int F13_VPL = 12;
        public const int F14_BIBLE_COMPANION = 13;
        public const int F15_GOBIBLE = 14;
        public const int F16_THML = 15;
        public const int F17_OPENSONG = 16;
        public const int F18_OPENLP = 17;
        public const int F19_MYSWORD = 18;
        public const int F20_BIBLE_ANALYZER = 19;
        public const int F21_EASY_SLIDES = 20;
        public const int F23_LOGOS = 22;
        public const int F24_ONLINEBIBLE = 23;
        public const int F25_PALMBIBLE = 24;
        public const int F26_HEAVENWORLD = 25;
        public const int F27_VERSEVIEW = 26;
        public const int F28_MYBIBLE = 27;        
        public const int F29_USFX = 28;
        public const int F30_SWORDSEARCHER = 29;

        ///


        static string filters = null;
        public string ABBREVIATION = "BIB";
        public string DESCRIPTION = "Bible";
        public string COMMENTS = "Exported from sbrcli ("+ GlobalMemory.AUTHOR_WEBSITE + ")";
		private Dictionary<string,int[]> chapterCount = new Dictionary<string, int[]>();
		private string m_filename;
		
		private static System.Xml.XmlDocument xmldoc = new System.Xml.XmlDocument();
		
		private bool process_complete = false;
		
		public static BibleFormat bible_format=null;

        public string rtf_header = @"{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f1\fnil\fprq2\fcharset161 TITUS cyberbit Basic;}{\f2\fnil\fprq2\fcharset177 TITUS Cyberbit Basic;}{\f3\fnil\fprq2\fcharset0 TITUS Cyberbit Basic;}{\f4\fnil\fprq2\fcharset136 PMingLiU;}{\f5\fnil\fprq2\fcharset204 Georgia;}{\f6\fnil\fprq2\fcharset238 Georgia;}{\f7\fnil\fprq2\fcharset134 PMingLiU;}{\f8\fnil\fprq2\fcharset222 Cordia New;}{\f9\fnil\fprq2\fcharset129 Gulim;}{\f10\fnil\fprq2\fcharset178 TITUS Cyberbit Basic;}{\f11\fnil\fprq2\fcharset162 Georgia;}{\f12\fnil\fprq2\fcharset163 Times New Roman;}{\f13\fnil\fprq2\fcharset128 MS Mincho;}}{\colortbl ;\red0\green0\blue0;\red0\green0\blue255;\red0\green255\blue255;\red0\green255\blue0;\red255\green0\blue255;\red255\green0\blue0;\red255\green255\blue0;\red255\green255\blue255;\red0\green0\blue128;\red0\green128\blue128;\red0\green128\blue0;\red128\green0\blue128;\red128\green0\blue0;\red128\green128\blue0;\red128\green128\blue128;\red192\green192\blue192;}{\viewkind4\uc1\pard\plain\cf0\fs\par}";
       

        public static bool isApocrypha = false;
        public bool CLEANING = false;

        public BibleFormat(string filename)
		{
			m_filename = filename;
			process_complete = false;
		}

        public static BibleFormat getInstance()
        {
            return bible_format;
        }

        public static void setInstance(BibleFormat mBibleFormat)
        {
            bible_format = mBibleFormat;
        }

        public static string getFormatTypes()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("\t0 - Auto Detect\r\n"); 
            sb.Append("\t1 - Zefania XML Bibles (*.xml)\r\n");  //idx =1
            sb.Append("\t2 - The Unbound Bible (Unmapped-BCV) (*.txt)\r\n");  //idx =2
            sb.Append("\t3 - The Unbound Bible (Unmapped-BCVS) (*.txt)\r\n");  //idx =3
            sb.Append("\t4 - Open Scripture Information Standard (OSIS) (*.xml)\r\n");  //idx =4
            sb.Append("\t5 - General Bible Format (GBF) (*.gbf)\r\n");  //idx =5
            sb.Append("\t6 - XML Scripture Encoding Model (XSEM) (*.xml)\r\n");  //idx =6
            sb.Append("\t7 - The Word Bible  (*.ont, *.ot, *.nt, *.ontx, *.otx, *.ntx)\r\n");  //idx =7
            sb.Append("\t9 - e-Sword Bible 9.x and above (BBLX) (*.bblx)\r\n");  //idx =9
            sb.Append("\t10 - e-Sword HD Bible (BBLI) (*.bbli)\r\n");  //idx =10
            sb.Append("\t11 - The SWORD Project (*.zip)\r\n");  //idx =11
            sb.Append("\t12 - Verse Per Line (*.vpl)\r\n");  //idx =12
            sb.Append("\t13 - Bible Companion (*.bib)\r\n");  //idx =13
            sb.Append("\t14 - Go Bible (*.jar)\r\n");  //idx =14
            sb.Append("\t15 - Theological Markup Language (ThML) (*.xml, *.thm, *.thml)\r\n");  //idx =15
            sb.Append("\t16 - Open Song Bibles (*.xmm, *.xml)\r\n");  //idx =16
            sb.Append("\t17 - OpenLP.org Bibles (*.sqlite)\r\n");  //idx =17
            sb.Append("\t18 - MySword for Android (*.bbl.mybible.gz, *.bbl.mybible)\r\n");  //idx =18
            sb.Append("\t19 - Bible Analyzer Bibles (*.bib)\r\n");  //idx =19
            sb.Append("\t22 - LOGOS Import File (*.docx)\r\n");  //idx =22
            sb.Append("\t23 - OnlineBible (*.exp)\r\n");  //idx =23
            sb.Append("\t24 - Palm Bible+ (*.pdb)\r\n");  //idx =24
            sb.Append("\t25 - HeavenWorld Bibles for Windows 8 (*.hbb)\r\n");  //idx =25
            sb.Append("\t26 - VerseVIEW (*.xml, *.db)\r\n");  //idx =26
            sb.Append("\t27 - MyBible (*.SQLite3, *.sqlite3)\r\n");  //idx =27
            sb.Append("\t28 - Unified Scripture Format XML (USFX) (*.xml)\r\n");  //idx =28
            sb.Append("\t29 - SwordSearcher/Forge for SwordSearcher (*.ss5bible, *.ss6bible, *.ss7bible, *.ss8bible, *.txt");  //idx =29
            return sb.ToString();
        }
        public static BibleFormat BibleFactory(string filename)
        {
            bible_format = null;
            if (filename.ToLower().EndsWith(".xml"))
            {                
                string xml_str = System.IO.File.ReadAllText(filename).Trim().ToLower();
                if (FormatUtil.InStr(xml_str, "<xmlbible"))
                {
                    xml_str = null;
                    bible_format = new ZefaniaBibleFormat(filename);
                }
                else if (FormatUtil.InStr(xml_str, "<osis"))
                {
                    xml_str = null;
                    bible_format = new OSISBibleFormat(filename);
                }                
                else if (FormatUtil.InStr(xml_str, "<usfx"))
                {
                    xml_str = null;
                    bible_format = new USFXBibleFormat(filename);
                }
                else if (FormatUtil.InStr(xml_str, "<thml"))
                {
                    xml_str = null;
                    bible_format = new ThMLBibleFormat(filename);
                }
                else if (FormatUtil.InStr(xml_str, "<scripture"))
                {
                    xml_str = null;
                    bible_format = new XSEMBibleFormat(filename);
                }
                else if (FormatUtil.InStr(xml_str, "<bible"))
                {
                    if (FormatUtil.InStr(xml_str, "<fname"))
                    {
                        xml_str = null;
                        bible_format = new VerseVIEWBibleFormat(filename);
                    }
                    else
                    {
                        xml_str = null;
                        bible_format = new OpenSongBibleFormat(filename);
                    }
                }  
            }
            else if (filename.ToLower().EndsWith(".thm") || filename.ToLower().EndsWith(".thml"))
            {
                bible_format = new ThMLBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".txt"))
            {
                StreamReader sr = File.OpenText(filename);
                string line = sr.ReadLine();
                sr.Close();
                if (line.StartsWith(";"))                
                    bible_format = new SwordSearcherBibleFormat(filename);
                else                
                    bible_format = new UnboundBibleFormat(filename,F02_UNBOUND_BIBLE_BCV); //default is BCV for drag drop or autodetect
            }
            else if (filename.ToLower().EndsWith(".gbf"))
            {
                bible_format = new GBFBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".ont"))
            {
                bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_ONT);
            }
            else if (filename.ToLower().EndsWith(".ot"))
            {
                bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_OT);
            }
            else if (filename.ToLower().EndsWith(".nt"))
            {
                bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_NT);
            }
            else if (filename.ToLower().EndsWith(".ontx"))
            {
                bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_ONTX);
            }
            else if (filename.ToLower().EndsWith(".otx"))
            {
                bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_OTX);
            }
            else if (filename.ToLower().EndsWith(".ntx"))
            {
                bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_NTX);
            }
            else if (filename.ToLower().EndsWith(".bblx"))
            {
                bible_format = new BBLXBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".bbli"))
            {
                bible_format = new BBLIBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".zip"))
            {
                bible_format = new SwordBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".vpl"))
            {
                bible_format = new VPLBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".jar"))
            {
                bible_format = new GoBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".xmm"))
            {
                bible_format = new OpenSongBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".sqlite"))
            {
                bible_format = new OpenLPBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".hbb"))
            {
                bible_format = new HeavenWorldBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".bib"))
            {
                // same extension for Bible Companion and Bible Analyzer
                FileStream fs = File.OpenRead(filename);
                try
                {
                    int count = "SQLite".Length;
                    byte[] bytes = new byte[count];
                    fs.Read(bytes, 0, count);
                    fs.Close();
                    if (Encoding.ASCII.GetString(bytes).Equals("SQLite"))
                        bible_format = new BibleAnalyzerBibleFormat(filename);
                    else
                        bible_format = new BibleCompanionBibleFormat(filename);
                }
                catch (Exception)
                {
                    fs.Close();
                }
            }            
            else if (filename.ToLower().EndsWith(".bbl.mybible.gz"))
            {
                bible_format = new MySword4AndroidBibleFormat(filename,true);
            }
            else if (filename.ToLower().EndsWith(".bbl.mybible"))
            {
                bible_format = new MySword4AndroidBibleFormat(filename, false);
            }
            else if (filename.ToLower().EndsWith(".docx"))
            {
                // required, all though not used
                bible_format = new LOGOSBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".exp"))
            {
                bible_format = new OnlineBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".sqlite3") && !filename.ToLower().EndsWith(".commentaries.sqlite3") && !filename.ToLower().EndsWith(".dictionary.sqlite3"))
            {
                bible_format = new MyBibleBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".pdb"))
            {
                bible_format = new PDBBibleFormat(filename);
            }
            else if (filename.ToLower().EndsWith(".ss8bible") || filename.ToLower().EndsWith(".ss7bible") || filename.ToLower().EndsWith(".ss6bible") || filename.ToLower().EndsWith(".ss5bible"))
            {
                bible_format = new SwordSearcherBibleFormat(filename);
            }
            else if (System.IO.Directory.Exists(filename))
            {
                //Its a directory
                if (System.IO.Directory.Exists(filename + Path.DirectorySeparatorChar+"mods.d"))
                {
                    bible_format = new SwordBibleFormat(filename);
                }
            }            

            if (bible_format != null)
            {
                if (cleaningRequired(bible_format.FilterIndex))
                {
                    bible_format.CLEANING = true;
                }

                if (bible_format.ABBREVIATION == "BIB")
                    bible_format.ABBREVIATION = Path.GetFileNameWithoutExtension(filename);
                if (bible_format.DESCRIPTION == "Bible")
                    bible_format.DESCRIPTION = Path.GetFileNameWithoutExtension(filename);                
            }

            //            
            return bible_format;
        }

        public static BibleFormat BibleFactory(string filename, int filterIdx)
        {
            if (filterIdx == 0)
                bible_format = BibleFactory(filename);
            else
                bible_format = getBibleFormat(filename, filterIdx);
            return bible_format;
        }

        public static BibleFormat getBibleFormat(string filename, int filterIdx)
        {
            BibleFormat bible_format = null;
            switch (filterIdx)
            {
                case F01_ZEFANIA_BIBLE:
                    bible_format = new ZefaniaBibleFormat(filename);
                    break;
                case F02_UNBOUND_BIBLE_BCV:
                    bible_format = new UnboundBibleFormat(filename, F02_UNBOUND_BIBLE_BCV);
                    break;
                case F03_UNBOUND_BIBLE_BCVS:
                    bible_format = new UnboundBibleFormat(filename, F03_UNBOUND_BIBLE_BCVS);
                    break;
                case F05_OSIS:
                    bible_format = new OSISBibleFormat(filename);
                    break;
                case F06_GBF:
                    bible_format = new GBFBibleFormat(filename);
                    break;
                case F07_XSEM:
                    bible_format = new XSEMBibleFormat(filename);
                    break;
                case F08_THEWORD:
                    bible_format = new TheWordBibleFormat(filename, TheWordBibleFormat.Type_ONT);
                    break;
                case F10_ESWORD_BBLX:
                    bible_format = new BBLXBibleFormat(filename);
                    break;
                case F11_ESWORD_BBLI:
                    bible_format = new BBLIBibleFormat(filename);
                    break;
                case F12_SWORDPROJECT:
                    bible_format = new SwordBibleFormat(filename);
                    break;
                case F13_VPL:
                    bible_format = new VPLBibleFormat(filename);
                    break;
                case F14_BIBLE_COMPANION:
                    bible_format = new BibleCompanionBibleFormat(filename);
                    break;
                case F15_GOBIBLE:
                    bible_format = new GoBibleFormat(filename);
                    break;
                case F16_THML:
                    bible_format = new ThMLBibleFormat(filename);
                    break;
                case F17_OPENSONG:
                    bible_format = new OpenSongBibleFormat(filename);
                    break;
                case F18_OPENLP:
                    bible_format = new OpenLPBibleFormat(filename);
                    break;
                case F19_MYSWORD:
                    bible_format = new MySword4AndroidBibleFormat(filename, true);
                    break;
                case F20_BIBLE_ANALYZER:
                    bible_format = new BibleAnalyzerBibleFormat(filename);
                    break;
                case F23_LOGOS:
                    bible_format = new LOGOSBibleFormat(filename);
                    break;
                case F24_ONLINEBIBLE:
                    bible_format = new OnlineBibleFormat(filename);
                    break;
                case F25_PALMBIBLE:
                    bible_format = new PDBBibleFormat(filename);
                    break;
                case F26_HEAVENWORLD:
                    bible_format = new HeavenWorldBibleFormat(filename);
                    break;
                case F27_VERSEVIEW:
                    bible_format = new VerseVIEWBibleFormat(filename);
                    break;
                case F28_MYBIBLE:
                    bible_format = new MyBibleBibleFormat(filename);
                    break;
                case F29_USFX:
                    bible_format = new USFXBibleFormat(filename);
                    break;
                case F30_SWORDSEARCHER:
                    bible_format = new SwordSearcherBibleFormat(filename);
                    break;

                default:
                    ConsoleUtil.addLog("Sorry, export for this Bible format is not yet implemented!");
                    return null;
            }
            return bible_format;
        }

        public static BibleFormat doExportBible(string filename,int filterIdx)
        {
            bool cleaing_required = bible_format.CLEANING;
            BibleFormat bible_format_export = getBibleFormat(filename,filterIdx);
            // if the loaded bible requires cleaning, the the target much clean it before export.
            if (bible_format_export != null)
            {
                bible_format_export.CLEANING = bible_format.CLEANING;
                bible_format_export.ABBREVIATION = bible_format.ABBREVIATION.Replace("'", "''");
                bible_format_export.DESCRIPTION = bible_format.DESCRIPTION.Replace("'", "''");
                bible_format_export.COMMENTS = bible_format.COMMENTS.Replace("'", "''");
                if (bible_format_export.ABBREVIATION == "BIB")
                    bible_format_export.ABBREVIATION = Path.GetFileNameWithoutExtension(filename).Replace("'", "''");
                if (bible_format_export.DESCRIPTION == "Bible")
                    bible_format_export.DESCRIPTION = Path.GetFileNameWithoutExtension(filename).Replace("'", "''");
            }
            return bible_format_export;
        }

        public static bool cleaningRequired(int FilterIdx)
        {
            int[] required = new int[] { F10_ESWORD_BBLX, F11_ESWORD_BBLI};
            for (int i = 0; i < required.Length; i++)
                if (required[i] == FilterIdx)
                    return true;            
            return false;
        }

		public void SetProcessAsComplete()
		{
			process_complete = true;
		}

		public static System.Xml.XmlDocument BibleXmlDocument
		{
			get
			{
				return xmldoc;
			}
			set
			{
				xmldoc = value;
			}
		}
		
		public string XML
		{
			get
			{
				return xmldoc.OuterXml;
			}
		}

        public static String PrintXML(String XML)
        {
            String Result = "";

            MemoryStream mStream = new MemoryStream();
            XmlTextWriter writer = new XmlTextWriter(mStream, Encoding.Unicode);
            XmlDocument document = new XmlDocument();

            try
            {
                // Load the XmlDocument with the XML.
                document.LoadXml(XML);

                writer.Formatting = Formatting.Indented;

                // Write the XML into a formatting XmlTextWriter
                document.WriteContentTo(writer);
                writer.Flush();
                mStream.Flush();

                // Have to rewind the MemoryStream in order to read
                // its contents.
                mStream.Position = 0;

                // Read MemoryStream contents into a StreamReader.
                StreamReader sReader = new StreamReader(mStream);

                // Extract the text from the StreamReader.
                String FormattedXML = sReader.ReadToEnd();

                Result = FormattedXML;
            }
            catch (XmlException ex)
            {
                
            }

            mStream.Close();
            writer.Close();

            return Result;
        }
		
		public string FileName
		{
			get
			{
				return m_filename;
			}
			set
			{
				m_filename = value;
			}
		}		
		
		
        public string getVerse(int book,int chapter,int verse)
        {
            XmlNode v = xmldoc.SelectSingleNode("/XMLBIBLE/BIBLEBOOK[@bnumber=\'" + book.ToString() + "\']/CHAPTER[@cnumber='" + chapter.ToString() + "']/VERS[@vnumber='"+verse.ToString()+"']");
            if (v != null)
                return v.InnerText;
            else
                return "";
        }

        public string getBookName(int book)
        {
            XmlNode v = xmldoc.SelectSingleNode("/XMLBIBLE/BIBLEBOOK[@bnumber=\'" + book.ToString() + "\']/@bname");
            if (v != null)
                return v.InnerText;
            else
                return Localization.getBookNames()[FormatUtil.zefaniaBookNoToIndex(book)];
        }

        public string getFirstVerse()
        {
            XmlNode v = xmldoc.SelectSingleNode("/XMLBIBLE/BIBLEBOOK[1]/CHAPTER[1]/VERS[1]");
            if (v != null)
                return v.InnerText;
            else
                return "";
        }	
		public bool IsComplete
		{
			get
			{
				return process_complete;
			}
		}
		
	
        public XmlDocument getXmlDoc()
        {
            return BibleXmlDocument;
        }

        public static string postProcessContent(string input, string rtf_header = null)
        {
            string output = input;
            if (GlobalMemory.getInstance().ParseBible)
            {
                if (GlobalMemory.getInstance().ConvertRtfToHtmlBible)
                {
                    output = FormatUtil.convertRtfToHtml(output);
                }
                else if(GlobalMemory.getInstance().autoSetParsingBible && BibleFormat.getInstance().CLEANING)
                {
                    // force cleaning rtf to html if set to auto and format requires it.
                    output = FormatUtil.convertRtfToHtml(output);
                }

                if (GlobalMemory.getInstance().ConvertHtmlToRtfBible)
                {
                    output = FormatUtil.convertHtmlToRtf(output);
                }

                // finally strip html
                if (GlobalMemory.getInstance().stripHtmlTagsBible)
                {
                    output = FormatUtil.StripHTML(output);
                }
            }
            return output;
        }

        public void addRedText()
        {
            XmlNodeList verses = BibleXmlDocument.SelectNodes("//VERS");

            int bno = -1;
            int cno = -1;
            int vno = -1;
            string verseText = null;
            string[] arrayRed = null;
            foreach (XmlNode verse in verses)
            {
                verseText = verse.InnerText;                
                int.TryParse(verse.Attributes["vnumber"].Value, out vno);
                int.TryParse(verse.ParentNode.Attributes["cnumber"].Value, out cno);
                int.TryParse(verse.ParentNode.ParentNode.Attributes["bnumber"].Value, out bno);

                if (RedTextUtil.isRedText(bno, cno, vno))
                {
                    verseText = Regex.Replace(verseText, @"\p{Cc}", "\"");

                    // complete verse is red text.
                    if (RedTextUtil.isRedTextComplete(bno, cno, vno))
                    {
                        verse.InnerXml = "<STYLE css=\"color:#ff0000\">\"" + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(verseText)) + "\"</STYLE>";                      
                    }
                    else
                    {
                        // partial verse is red text.
                        string splitChar = "\"";
                        verseText = verseText.Replace('', '"').Replace('', '"');
                        if (verseText.Contains("\"") && verseText.Contains("'"))
                        {
                            arrayRed = verseText.Split(new char[] { '"' });
                            splitChar = "\"";
                        }
                        else if (verseText.Contains("\"") && !verseText.Contains("'"))
                        {
                            arrayRed = verseText.Split(new char[] { '"' });
                            splitChar = "\"";
                        }
                        else if (verseText.Contains("'") && !verseText.Contains("\""))
                        {
                            arrayRed = verseText.Split(new char[] { '\'' });
                            splitChar = "\'";
                        }
                        if (arrayRed == null)
                        {
                            verse.InnerXml = "<STYLE css=\"color:#ff0000\">" + splitChar + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(verseText)) + splitChar + "</STYLE>";
                            continue;
                        }


                        if (arrayRed.Length == 1 && verseText.Trim() != "")
                        {
                            // doesn't have any quotes. prob non-english
                            verse.InnerXml = "<STYLE css=\"color:#ff0000\">" + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(verseText)) + "</STYLE>";
                        }
                        else if (arrayRed.Length == 2)
                        {
                            // only one quote found., hence, starts middle and ends at last
                           verse.InnerXml = FormatUtil.EscapeXML(FormatUtil.UnescapeXML(arrayRed[0])) + "<STYLE css=\"color:#ff0000\">" + splitChar + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(arrayRed[1])) + splitChar + "</STYLE>";
                        }
                        else if (arrayRed.Length == 3)
                        {
                            // 2 quote found. hence, the middle segment is red.
                            verse.InnerXml = FormatUtil.EscapeXML(FormatUtil.UnescapeXML(arrayRed[0])) + "<STYLE css=\"color:#ff0000\">"+ splitChar + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(arrayRed[1])) + splitChar+"</STYLE>" + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(arrayRed[2]));
                        }
                        else //default is complete verse
                        {
                            if (verseText.Trim() != "")
                                verse.InnerXml = "<STYLE css=\"color:#ff0000\">"+ splitChar + FormatUtil.EscapeXML(FormatUtil.UnescapeXML(verseText)) + splitChar+"</STYLE>";
                        }
                    }
                }
            }
        }

		public abstract void Load();
		public abstract int PercentComplete {get;}

        public virtual string AdditionaStatusText() { return ""; }
        public abstract int FilterIndex {get;}

        public abstract void ExportBible(string filename, int idx);
	}
	
}
