﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Collections;
using System.Xml;
using System.IO;
using System.Threading.Tasks;
using Sword;

namespace sbrcli
{
    public class ConsoleUtil
    {

        public static ArrayList msg = new ArrayList();

        public static string logFile = "console";
        public static void addLog(String errmsg)
        {
            msg.Add(errmsg);
        }

        public static void writeLog(String filename)
        {
            string[] err_array = new string[msg.Count];
            for (int i = 0; i < msg.Count; i++)
                err_array[i] = (string)msg[i];
            File.WriteAllLines(filename, err_array);
        }

        public static void displayLog()
        {
            string[] err_array = new string[msg.Count];
            for (int i = 0; i < msg.Count; i++)
            {
             Console.WriteLine((string)msg[i]);
            }
        }

        public static void Convert(string format_type, int in_type, string in_File, int out_type, string out_File, bool mClean,string meta_abbr, string meta_desc, string meta_comment)
        {
            CLIDebug("[Begin Conversion]");
            CLIDebug("Parameters:");
            CLIDebug(" --format-type   = " + format_type);
            CLIDebug(" --input-format  = " + in_type);
            CLIDebug(" --input-file    = " + in_File);
            CLIDebug(" --output-format = " + out_type);
            CLIDebug(" --output-file   = " + out_File);
            CLIDebug(" --clean         = " + mClean);

            CLIDebug("Preferences:");
            //
            //
            DateTime begin = DateTime.Now;
            switch (format_type.ToLower())
            {
                case "bib":
                    CLIDebug(" --parse  = " + GlobalMemory.getInstance().ParseBible);
                    CLIDebug(" --autoset-parsing  = " + GlobalMemory.getInstance().autoSetParsingBible);
                    CLIDebug(" --convert-rtf-to-html  = " + GlobalMemory.getInstance().ConvertRtfToHtmlBible);
                    CLIDebug(" --convert-html-to-rtf  = " + GlobalMemory.getInstance().ConvertHtmlToRtfBible);
                    CLIDebug(" --strip-html-tags  = " + GlobalMemory.getInstance().stripHtmlTagsBible);
                    CLIDebug(" --sword-versification  = " + GlobalMemory.getInstance().Versification);
                    CLIDebug(" --add-red-text  = " + GlobalMemory.getInstance().addRedText);
                    CLIDebug(" --custom-parser  = " + GlobalMemory.getInstance().CustomParserScript);
                    //
                    BibleFormat bible_format_input = null;
                    if(in_type==0)
                        bible_format_input = BibleFormat.BibleFactory(in_File);
                    else
                        bible_format_input = BibleFormat.BibleFactory(in_File, in_type);
                    if (bible_format_input == null)
                    {
                        addLog("Invalid input type of '" + in_type + "' specified for '" + format_type+"'");
                        break;
                    }

                    CLIDebug("Loading Bible ... "+ in_File);
                    bible_format_input.Load();
                    
                    bible_format_input.ABBREVIATION = meta_abbr;
                    bible_format_input.DESCRIPTION = meta_desc;
                    bible_format_input.COMMENTS = meta_comment;

                    CLIDebug("[Metadata]");
                    CLIDebug(meta_abbr+","+ meta_desc+","+ meta_comment);

                    CLIDebug("Bible loaded successfully.");

                    //     
                    if (mClean)
                    {
                        GlobalMemory.getInstance().ParseBible = true;
                        bible_format_input.CLEANING = true;
                        clean(true);
                    }
                    else
                    {
                        bible_format_input.CLEANING = false;
                        GlobalMemory.getInstance().ParseBible = false;
                    }

                    CustomParser.doParse(format_type);

                    //
                    BibleFormat bible_format_export = BibleFormat.doExportBible(out_File, out_type);
                    if (bible_format_export == null)
                    {
                        addLog("Invalid output type of '" + out_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    bible_format_export.CLEANING = false;
                    if (bible_format_export == null)
                    {
                        addLog("Error in creating export file.");
                    }
                    CLIDebug("Exporting bible ... "+out_File);
                    bible_format_export.ExportBible(out_File, out_type);
                    CLIDebug("Bible exported successfully");
                    break;

                case "cmt":
                    CLIDebug(" --parse  = " + GlobalMemory.getInstance().ParseCommentary);
                    CLIDebug(" --autoset-parsing  = " + GlobalMemory.getInstance().autoSetParsingCommentary);
                    CLIDebug(" --convert-rtf-to-html  = " + GlobalMemory.getInstance().ConvertRtfToHtmlCommentary);
                    CLIDebug(" --convert-html-to-rtf  = " + GlobalMemory.getInstance().ConvertHtmlToRtfCommentary);
                    CLIDebug(" --strip-html-tags  = " + GlobalMemory.getInstance().stripHtmlTagsCommentary);
                    //
                    CommentaryFormat commentary_format_input = null;
                    if (in_type == 0)
                        commentary_format_input = CommentaryFormat.CommentaryFactory(in_File);
                    else
                        commentary_format_input = CommentaryFormat.CommentaryFactory(in_File, in_type);
                    if (commentary_format_input == null)
                    {
                        addLog("Invalid input type of '" + in_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    CLIDebug("Loading Commentary ... " + in_File);
                    commentary_format_input.Load();
                    CLIDebug("Commentary loaded successfully.");
                    //           
                    if (mClean)
                    {
                        GlobalMemory.getInstance().ParseCommentary = true;
                        commentary_format_input.CLEANING = true;
                    }
                    else
                    {
                        commentary_format_input.CLEANING = false;
                        GlobalMemory.getInstance().ParseCommentary = false;
                    }
                    //
                    CustomParser.doParse(format_type);
                    //
                    CommentaryFormat commentary_format_export = CommentaryFormat.doExportCommentary(out_File, out_type);
                    if (commentary_format_export == null)
                    {
                        addLog("Invalid output type of '" + out_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    commentary_format_export.CLEANING = false;
                    if (commentary_format_export == null)
                    {
                        addLog("Error in creating export file.");
                    }
                    CLIDebug("Exporting Commentary ... " + out_File);
                    commentary_format_export.ExportCommentary(out_File, out_type);
                    CLIDebug("Commentary exported successfully");
                    break;

                case "dct":
                    CLIDebug(" --parse  = " + GlobalMemory.getInstance().ParseDictionary);
                    CLIDebug(" --autoset-parsing  = " + GlobalMemory.getInstance().autoSetParsingDictionary);
                    CLIDebug(" --convert-rtf-to-html  = " + GlobalMemory.getInstance().ConvertRtfToHtmlDictionary);
                    CLIDebug(" --convert-html-to-rtf  = " + GlobalMemory.getInstance().ConvertHtmlToRtfDictionary);
                    CLIDebug(" --strip-html-tags  = " + GlobalMemory.getInstance().stripHtmlTagsDictionary);
                    //
                    DictionaryFormat dictionary_format_input = null;
                    if (in_type == 0)
                        dictionary_format_input = DictionaryFormat.DictionaryFactory(in_File);
                    else
                        dictionary_format_input = DictionaryFormat.DictionaryFactory(in_File, in_type);
                    if (dictionary_format_input == null)
                    {
                        addLog("Invalid input type of '" + in_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    CLIDebug("Loading Dictionary ... " + in_File);
                    dictionary_format_input.Load();
                    CLIDebug("Dictionary loaded successfully.");
                    //           
                    if (mClean)
                    {
                        GlobalMemory.getInstance().ParseDictionary = true;
                        dictionary_format_input.CLEANING = true;
                    }
                    else
                    {
                        dictionary_format_input.CLEANING = false;
                        GlobalMemory.getInstance().ParseDictionary = false;
                    }
                    //
                    CustomParser.doParse(format_type);
                    //
                    DictionaryFormat dictionary_format_export = DictionaryFormat.doExportDictionary(out_File, out_type);
                    if (dictionary_format_export == null)
                    {
                        addLog("Invalid output type of '" + out_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    dictionary_format_export.CLEANING = false;
                    if (dictionary_format_export == null)
                    {
                        addLog("Error in creating export file.");
                    }
                    CLIDebug("Exporting Dictionary ... " + out_File);
                    dictionary_format_export.ExportDictionary(out_File, out_type);
                    CLIDebug("Dictionary exported successfully");
                    break;

                case "bok":
                    CLIDebug(" --parse  = " + GlobalMemory.getInstance().ParseBook);
                    CLIDebug(" --autoset-parsing  = " + GlobalMemory.getInstance().autoSetParsingBook);
                    CLIDebug(" --convert-rtf-to-html  = " + GlobalMemory.getInstance().ConvertRtfToHtmlBook);
                    CLIDebug(" --convert-html-to-rtf  = " + GlobalMemory.getInstance().ConvertHtmlToRtfBook);
                    CLIDebug(" --strip-html-tags  = " + GlobalMemory.getInstance().stripHtmlTagsBook);
                    //
                    BookFormat book_format_input = null;
                    if (in_type == 0)
                        book_format_input = BookFormat.BookFactory(in_File);
                    else
                        book_format_input = BookFormat.BookFactory(in_File, in_type);
                    if (book_format_input == null)
                    {
                        addLog("Invalid input type of '" + in_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    CLIDebug("Loading Book ... " + in_File);
                    book_format_input.Load();
                    CLIDebug("Book loaded successfully.");
                    //           
                    if (mClean)
                    {
                        GlobalMemory.getInstance().ParseBook = true;
                        book_format_input.CLEANING = true;
                        clean(true);
                    }
                    else
                    {
                        book_format_input.CLEANING = false;
                        GlobalMemory.getInstance().ParseBook = false;
                    }
                    //
                    CustomParser.doParse(format_type);
                    //
                    BookFormat book_format_export = BookFormat.doExportBook(out_File, out_type);
                    if (book_format_export == null)
                    {
                        addLog("Invalid output type of '" + out_type + "' specified for '" + format_type + "'");
                        break;
                    }
                    book_format_export.CLEANING = false;
                    if (book_format_export == null)
                    {
                        addLog("Error in creating export file.");
                    }
                    CLIDebug("Exporting Book ... " + out_File);
                    book_format_export.ExportBook(out_File, out_type);
                    CLIDebug("Book exported successfully");
                    break;
                default:
                    goto case "bib";
            }
            CLIDebug("[End Conversion]");
            DateTime end= DateTime.Now;
            double sec = end.Subtract(begin).TotalSeconds;
            CLIDebug("Conversion completed in " + sec.ToString() + " seconds.");
        }

        public static void CLIDebug(string msg)
        {
            msg = "DEBUG: " + msg;
            if (GlobalMemory.getInstance().DevMode)
            {
                if (logFile == "console")
                    Console.WriteLine(msg);
                else
                    addLog (msg);
            }
        }

        public static void checkAndSetSwordLibrary()
        {
            try
            {
                CLIDebug("Checking Sword Engine ..");
                Manager manager = new Manager();
                CLIDebug("List of available Sword Modules installed.");
                foreach (var mod in manager.GetModInfoList())
                {
                    CLIDebug(">> "+mod.Name + " v" + mod.Version);
                }
                CLIDebug("Sword Engine is available.");
                GlobalMemory.getInstance().use_libsword = true;
            }
            catch (Exception ex)
            {
                CLIDebug("Exception Message = " + ex.Message);
                CLIDebug("Sword Engine is not available.");
                GlobalMemory.getInstance().use_libsword = false;
            }
        }


        public static void clean(bool is_bible)
        {
            XmlNodeList verses;
            // background cleaner is only for Bible and Books. cleaning on dictionary and commentary takes place during load.
            if (is_bible)
                verses = BibleFormat.getInstance().getXmlDoc().SelectNodes("//VERS");
            else
                verses = BookFormat.getInstance().getXmlDoc().SelectNodes("//NOTES");

            if (verses == null)
                return;
            int count = 0;
            foreach (XmlNode verse in verses)
            {
                try
                {
                    count++;
                    verse.InnerXml = FormatUtil.convertRtfToHtml(verse.InnerText);
                }
                catch (Exception)
                {
                    //ConsoleUtil.addLog(ex.Message);                   
                }
            }
        }
    }
}
