﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace sbrcli
{
    public class GlobalMemory
    {
        public bool dev_mode = false;

        public const string AUTHOR_WEBSITE = "trumpet-call.org/sbrcli/";

        static GlobalMemory _gm = null;

        public const int DIRECTION_LTR = 0;
        public const int DIRECTION_RTL = 1;        

        int _dir = 0;

        public double ZOOMFACTOR_IDX_BIB = 1.0;
        public double ZOOMFACTOR_IDX_CMT = 1.0;
        public double ZOOMFACTOR_IDX_DICT = 1.0;

        string font_family_bib = "";
        string font_family_cmt = "";
        string font_family_dct = "";

        public string Locale = "en";
       
        bool transliterate = false;

        public bool ParseBible = true;
        public bool parseBibleBkgndCleaner = false;

        public bool ParseCommentary = true;
        public bool ParseDictionary = true;
        
        public bool ParseBook = true;
        public bool parseBookBkgndCleaner = false;

        public bool CommentaryIcon = true;

        public bool addRedText = false;

        public bool EnableCustomParser = false;
        public string CustomParserScript = "";

        public bool ConsoleMode = true;

        public bool use_libsword = true;
       

        public bool ConvertRtfToHtmlBible = false;
        public bool ConvertRtfToHtmlCommentary = false;
        public bool ConvertRtfToHtmlDictionary = false;
        public bool ConvertRtfToHtmlBook = false;

        public bool ConvertHtmlToRtfBible = false;
        public bool ConvertHtmlToRtfCommentary = false;
        public bool ConvertHtmlToRtfDictionary = false;
        public bool ConvertHtmlToRtfBook = false;

        public bool stripHtmlTagsBible = false;
        public bool stripHtmlTagsBook = false;
        public bool stripHtmlTagsCommentary = false;
        public bool stripHtmlTagsDictionary = false;

        public bool autoSetParsingBible = true;
        public bool autoSetParsingBook = true;
        public bool autoSetParsingCommentary = true;
        public bool autoSetParsingDictionary = true;

        public string Versification = "kjva";

        public ArrayList PluginsList = new ArrayList();


        public static GlobalMemory getInstance()
        {
            if (_gm == null)
                _gm = new GlobalMemory();
            return _gm;
        }

        public bool DevMode
        {
            get
            {
                return dev_mode;
            }
            set
            {
                dev_mode = value;
            }
        }

        public bool Transliteration
        {
            get
            {
                return transliterate;
            }
            set
            {
                transliterate = value;
            }
        }

        public int Direction
        {
            get
            {
                return _dir;
            }
            set
            {
                _dir = value;
            }
        }

        public string FontFamilyBIB
        {
            get
            {
                return font_family_bib;
            }
            set
            {
                font_family_bib = value;
            }
        }

        public string FontFamilyCMT
        {
            get
            {
                return font_family_cmt;
            }
            set
            {
                font_family_cmt = value;
            }
        }

        public string FontFamilyDICT
        {
            get
            {
                return font_family_dct;
            }
            set
            {
                font_family_dct = value;
            }
        }
    }
}
