﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace sbrcli
{
    public class SwordVersification
    {
        // adopted from https://gitlab.com/tgc-dk/pysword/-/blob/master/pysword/canons.py


        static Dictionary<string, Dictionary<string, List<Book>[]>> mVersificationData = new Dictionary<string, Dictionary<string, List<Book>[]>> { {
        "kjv",
        new Dictionary < string,
        List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,40,16,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,15,23,29,22,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,53
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,24,34,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,8,8,12,10,17,9,20,18,7,8,6,7,5,11,15,50,14,9,13,31,6,10,22,12,14,9,11,12,24,11,22,22,28,12,40,22,13,17,13,11,5,26,17,11,9,14,20,23,19,9,6,7,23,13,11,11,17,12,8,12,11,10,13,20,7,35,36,5,24,20,28,23,10,12,20,72,13,19,16,8,18,12,13,17,7,18,52,17,16,15,5,23,11,13,12,9,9,5,8,28,22,35,45,48,43,13,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,13,10,7,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,16,20,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,13,13,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,12,14,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    17,10,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,14
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    14
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,17,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "calvin",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,15,34,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,15,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,38,38,28,25,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,16,20,12,29,17,18,20,8,16
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,13,13,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,20,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,11,15,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            }
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,51,53,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,40,38,40,30,35,28,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,30,25,21,23,25,38,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,22,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "catholic",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,54,33,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,37,30,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,35,28,32,22,29,35,41,30,25,19,66,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,31,19,29,23,22,20,22,21,20,23,29,26,22,19,19,26,69,28,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,32,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,16,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,32,44,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,20,32,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,20,22,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,66,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,17,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,38,17,19,19,73,18,37,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,23,19,17,21,6,14,19,22,18,15
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,14,25
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,54,53,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,32,40,50,27,31,42,36,29,38,38,46,26,46,39
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,14,14,24,28,25,31,40,22,33,37,16,33,24,41,30,32,26,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,24,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,9,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,17,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,24,19,20,23,25,30,21,19,21,26,27,19,31,19,29,21,25,22
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,31,17,37,36,19,18,31,34,18,26,27,20,30,32,33,30,32,28,27,28,34,26,29,30,26,28,25,31,24,33,31,26,31,31,34,35,30,27,25,35,23,26,20,25,25,16,29,30
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,24,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,25,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9,72
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,100,34,30,29,28,27,27,21,45,13,64,43
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,27,5,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    17,17,10,16,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,49,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "catholic2",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,54,33,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,37,30,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,35,28,32,22,29,35,41,30,25,19,66,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,31,19,29,23,22,20,22,21,20,23,29,26,22,19,19,26,69,28,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,32,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,16,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,32,44,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,20,32,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,20,22,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,66,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,17,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,38,17,19,19,73,18,37,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,23,19,17,21,6,14,19,22,18,15
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,14,25
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,13,12,6,18,19,19,24
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,54,53,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,32,40,50,27,31,42,36,29,38,38,46,26,46,39
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,14,14,24,28,25,31,40,22,33,37,16,33,24,41,30,32,26,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,24,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,9,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,17,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,24,19,20,23,25,30,21,19,21,26,27,19,31,19,29,21,25,22
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,31,17,37,36,19,18,31,34,18,26,27,20,30,32,33,30,32,28,27,28,34,26,29,30,26,28,25,31,24,33,31,26,31,31,34,35,30,27,25,35,23,26,20,25,25,16,29,30
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,24,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,25,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9,72
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,100,34,30,29,28,27,27,21,45,13,64,43
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,27,5,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    17,17,10,16,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,49,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "darbyfr",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,15,34,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,40,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,69,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,15,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,38,38,27,25,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,8,8,12,10,17,9,20,18,7,8,5,7,5,11,15,50,14,9,13,31,6,10,22,12,14,9,11,12,24,11,22,22,28,12,40,22,13,17,13,11,5,26,17,11,9,14,20,23,19,9,6,7,23,13,11,11,17,12,8,12,11,10,13,20,7,35,36,5,24,20,28,23,10,12,20,72,13,19,16,8,18,12,13,17,7,18,52,17,16,15,5,23,11,13,12,9,9,5,8,28,22,35,45,48,43,13,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,13,10,7,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,16,20,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,13,13,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,11,15,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,51,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    52,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "german",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,54,33,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,37,30,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,35,28,32,22,29,35,41,30,25,19,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,31,19,29,23,22,20,22,21,20,23,29,26,22,19,19,26,69,28,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,16,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,32,44,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,20,32,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,20,22,25,29,39,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,66,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,17,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,38,17,19,19,73,18,37,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,32,26,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,20,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,25,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,33,34,30,29,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,27,5,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    17,17,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,40,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "kjva",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,40,16,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,15,23,29,22,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,53
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,24,34,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,8,8,12,10,17,9,20,18,7,8,6,7,5,11,15,50,14,9,13,31,6,10,22,12,14,9,11,12,24,11,22,22,28,12,40,22,13,17,13,11,5,26,17,11,9,14,20,23,19,9,6,7,23,13,11,11,17,12,8,12,11,10,13,20,7,35,36,5,24,20,28,23,10,12,20,72,13,19,16,8,18,12,13,17,7,18,52,17,16,15,5,23,11,13,12,9,9,5,8,28,22,35,45,48,43,13,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,13,10,7,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,16,20,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,13,13,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,12,14,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    17,10,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                            new List < Book > {
                                "I Esdras",
                                "1Esd",
                                new int[]{
                                    58,30,24,63,73,34,15,96,55
                                }
                            },
                            new List < Book > {
                                "II Esdras",
                                "2Esd",
                                new int[]{
                                    40,48,36,52,56,59,70,63,47,59,46,51,58,48,63,78
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,22,17,18,21,6,12,19,22,18,15
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,13,25
                                }
                            },
                            new List < Book > {
                                "Additions to Esther",
                                "AddEsth",
                                new int[]{
                                    1,1,1,1,1,1,1,1,1,13,12,6,18,19,16,24
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,24,19,20,23,25,30,21,18,21,26,27,19,31,19,29,21,25,22
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,31,15,37,36,19,18,31,34,18,26,27,20,30,32,33,30,32,28,27,28,34,26,29,30,26,28,25,31,24,31,26,20,26,31,34,35,30,24,25,33,22,26,20,25,25,16,29,30
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,37,37,9,73
                                }
                            },
                            new List < Book > {
                                "Prayer of Azariah",
                                "PrAzar",
                                new int[]{
                                    68
                                }
                            },
                            new List < Book > {
                                "Susanna",
                                "Sus",
                                new int[]{
                                    64
                                }
                            },
                            new List < Book > {
                                "Bel and the Dragon",
                                "Bel",
                                new int[]{
                                    42
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    1
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,53,53,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,32,40,50,27,31,42,36,29,38,38,45,26,46,39
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,14
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    14
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,17,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "leningrad",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,54,33,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,37,30,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,35,28,32,22,29,35,41,30,25,19,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,31,19,29,23,22,20,22,21,20,23,29,26,22,19,19,26,69,28,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,16,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,32,44,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,20,32,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,20,22,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,20,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,25,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,27,5,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    17,17,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,66,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,17,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,32,26,17
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,33,34,30,29,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,38,17,19,19,72,18,37,40,36,47,31
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{}
                    }
                }
            }, {
                "luther",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,54,33,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,37,30,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,35,28,32,22,29,35,41,30,25,19,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,31,19,29,23,22,20,22,21,20,23,29,26,22,19,19,26,69,28,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,16,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,32,44,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,20,32,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,20,22,25,29,39,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,66,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,17,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,38,17,19,19,73,18,37,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,32,26,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,20,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,25,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,33,34,30,29,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,27,5,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    17,17,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    11,18,12,14,26,20,24,28,15,21,17,21,31,16,16,31
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,25,19,20,24,27,30,21,19,21,26,27,19,31,19,29,21,25,21
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    25,23,25,22,29,23,20,23,12,13,20,22,22,17
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    38,23,34,36,18,37,40,22,25,34,35,19,32,27,21,30,31,33,27,33,31,33,37,47,34,28,33,30,35,27,40,28,32,31,26,28,34,39,41,32,29,26,37,26,32,23,31,28,20,31,38
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9,73
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    68,70,60,61,68,63,50,32,73,89,74,54,54,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,33,40,50,27,31,42,36,29,38,38,46,26,46,40
                                }
                            },
                            new List < Book > {
                                "Additions to Esther",
                                "AddEsth",
                                new int[]{
                                    4,8,12,12,16,9,8
                                }
                            },
                            new List < Book > {
                                "Additions to Daniel",
                                "AddDan",
                                new int[]{
                                    64,41,66
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    16
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,40,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "lxx",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,25,26,32,23,24,22,29,32,32,20,18,24,21,16,27,33,39,18,34,24,20,67,34,35,46,22,35,43,55,33,20,31,29,44,36,30,23,23,57,39,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,32,35,29,10,51,22,31,27,36,16,27,25,26,37,31,33,18,40,37,21,43,46,38,18,35,23,35,35,40,21,29,23,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,40,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,34,45,41,50,28,32,22,29,35,41,30,25,18,65,23,31,40,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,19,29,23,22,20,22,21,20,23,30,26,24,19,19,27,69,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,16,27,26,35,33,43,23,24,33,15,64,10,18,28,54,9,49,34,16,36
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,32,40,25,35,57,18,40,15,25,20,20,31,13,32,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,16,23,29,23,44,25,12,25,11,32,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,26,23,29,18,13,19,27,31,39,33,37,23,29,33,44,26,22,51,41,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,71,39,34,32,38,51,66,28,33,44,54,34,31,34,42,24,46,21,43,43,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    22,25,27,44,27,35,20,29,37,36,21,22,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,81,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,18,17,23,14,42,22,18,31,19,23,16,23,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,31,31
                                }
                            },
                            new List < Book > {
                                "I Esdras",
                                "1Esd",
                                new int[]{
                                    58,30,24,63,73,34,15,96,55
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,37,23,19,19,73,18,38,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,22,14,10,17,35,13,17,7,30,19,24,24
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,14,25
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,23,19,18,21,6,14,19,22,19,15
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,53,54,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,32,40,50,27,31,42,36,29,38,38,46,26,46,39
                                }
                            },
                            new List < Book > {
                                "III Maccabees",
                                "3Macc",
                                new int[]{
                                    29,33,30,21,51,41,23
                                }
                            },
                            new List < Book > {
                                "IV Maccabees",
                                "4Macc",
                                new int[]{
                                    35,24,21,26,38,35,25,29,32,21,27,20,27,20,32,25,24,24
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,13,9,9,13,11,18,10,40,8,9,6,7,6,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,6,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,19,14,9,13,12,11,14,20,8,36,37,7,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,36,45,48,43,14,31,7,10,10,9,26,18,19,2,29,176,7,8,9,4,8,5,7,5,6,8,8,3,18,3,3,21,26,9,8,24,15,10,8,12,15,22,10,11,20,14,9,6,7
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    35,23,38,28,23,40,28,37,25,33,31,31,27,36,38,33,30,24,29,30,31,31,36,77,31,29,29,30,49,35,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,20,12,30,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,17,13,14,15
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,18,26,21,27,30,22,22,35,22,20,25,28,22,35,23,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,34,24,41,35,32,34,22
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,25,19,20,24,27,30,21,19,21,27,27,19,31,19,29,21,25,22
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,31,15,37,36,19,18,31,34,18,26,27,20,30,32,33,31,32,28,27,28,34,26,29,30,26,28,40,31,26,33,31,26,31,31,35,35,30,27,27,33,24,26,20,25,25,16,29,30
                                }
                            },
                            new List < Book > {
                                "Psalms of Solomon",
                                "PssSol",
                                new int[]{
                                    8,41,16,29,22,9,10,40,20,9,9,8,12,10,15,15,51,14
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,25,5,19,15,12,16,14,17,15,12,15,16,10
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,15,17,14,15
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,15,16,20
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21,21
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    17,11,10,11
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,21
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,24
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,17,11,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24,6
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,26,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,20,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,26,25,23,17,27,22,21,21,27,23,15,18,14,30,42,10,39,28,46,64,31,33,47,44,24,22,19,32,24,40,44,26,22,22,32,30,28,28,16,44,38,46,63,34
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Epistle of Jeremiah",
                                "EpJer",
                                new int[]{
                                    73
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,13,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Prayer of Azariah",
                                "PrAzar",
                                new int[]{
                                    68
                                }
                            },
                            new List < Book > {
                                "Susanna",
                                "Sus",
                                new int[]{
                                    64
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,100,37,31,29,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Bel and the Dragon",
                                "Bel",
                                new int[]{
                                    42
                                }
                            },
                            new List < Book > {
                                "I Enoch",
                                "1En",
                                new int[]{
                                    9,3,1,1,10,8,6,4,11,22,2,6,10,25,12,4,8,16,3,8,10,14,4,6,7,6,5,3,2,3,3,6,4,3,1,4,6,6,14,10,9,3,4,1,6,8,4,10,4,5,5,9,7,10,4,8,3,6,3,25,13,16,12,2,12,3,13,5,30,4,17,37,8,17,9,14,9,17,6,8,10,20,11,6,10,6,4,3,77,43,19,17,14,11,7,8,10,16,16,13,9,11,15,13,2,19,3,15
                                }
                            },
                            new List < Book > {
                                "Odes",
                                "Odes",
                                new int[]{
                                    19,43,10,20,20,19,45,88,79,88,55,32,79,46
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    52,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,26,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,14
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,9,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "mt",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,54,33,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,37,30,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,35,28,32,22,29,35,41,30,25,19,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,31,19,29,23,22,20,22,21,20,23,29,26,22,19,19,26,69,28,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,16,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,32,44,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,20,32,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,20,22,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,20,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,25,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,27,5,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    17,17,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,32,26,17
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,33,34,30,29,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,38,17,19,19,72,18,37,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,66,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,17,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{}
                    }
                }
            }, {
                "nrsv",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,40,16,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,15,23,29,22,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,53
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,24,34,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,8,8,12,10,17,9,20,18,7,8,6,7,5,11,15,50,14,9,13,31,6,10,22,12,14,9,11,12,24,11,22,22,28,12,40,22,13,17,13,11,5,26,17,11,9,14,20,23,19,9,6,7,23,13,11,11,17,12,8,12,11,10,13,20,7,35,36,5,24,20,28,23,10,12,20,72,13,19,16,8,18,12,13,17,7,18,52,17,16,15,5,23,11,13,12,9,9,5,8,28,22,35,45,48,43,13,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,13,10,7,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,16,20,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,13,13,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,12,14,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    17,10,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,14
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "nrsva",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,40,16,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,42,15,23,29,22,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,53
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,30,24,34,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,8,8,12,10,17,9,20,18,7,8,6,7,5,11,15,50,14,9,13,31,6,10,22,12,14,9,11,12,24,11,22,22,28,12,40,22,13,17,13,11,5,26,17,11,9,14,20,23,19,9,6,7,23,13,11,11,17,12,8,12,11,10,13,20,7,35,36,5,24,20,28,23,10,12,20,72,13,19,16,8,18,12,13,17,7,18,52,17,16,15,5,23,11,13,12,9,9,5,8,28,22,35,45,48,43,13,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,13,10,7,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,16,20,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,13,13,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,12,14,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    17,10,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,22,18,16,21,6,13,18,22,17,15
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,14,25
                                }
                            },
                            new List < Book > {
                                "Esther {Greek}",
                                "EsthGr",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,13,12,6,18,19,16,24
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,24,19,20,23,25,30,21,18,21,26,27,19,31,19,29,21,25,22
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,31,15,37,36,19,18,31,34,18,26,27,20,30,32,33,30,31,28,27,27,34,26,29,30,26,28,25,31,24,33,31,26,31,31,34,35,30,22,25,33,23,26,20,25,25,16,29,30
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,37,37,9,73
                                }
                            },
                            new List < Book > {
                                "Prayer of Azariah",
                                "PrAzar",
                                new int[]{
                                    68
                                }
                            },
                            new List < Book > {
                                "Susanna",
                                "Sus",
                                new int[]{
                                    64
                                }
                            },
                            new List < Book > {
                                "Bel and the Dragon",
                                "Bel",
                                new int[]{
                                    42
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,53,53,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,32,40,50,27,31,42,36,29,38,38,45,26,46,39
                                }
                            },
                            new List < Book > {
                                "I Esdras",
                                "1Esd",
                                new int[]{
                                    58,30,24,63,73,34,15,96,55
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Additional Psalm",
                                "AddPs",
                                new int[]{
                                    7
                                }
                            },
                            new List < Book > {
                                "III Maccabees",
                                "3Macc",
                                new int[]{
                                    29,33,30,21,51,41,23
                                }
                            },
                            new List < Book > {
                                "II Esdras",
                                "2Esd",
                                new int[]{
                                    40,48,36,52,56,59,140,63,47,59,46,51,58,48,63,78
                                }
                            },
                            new List < Book > {
                                "IV Maccabees",
                                "4Macc",
                                new int[]{
                                    35,24,21,26,38,35,23,29,32,21,27,19,27,20,32,25,24,24
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,14
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "orthodox",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,25,26,32,23,24,22,29,32,32,20,18,24,21,16,27,33,39,18,34,24,20,67,34,35,46,22,35,43,55,33,20,31,29,44,36,30,23,23,57,39,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,32,35,29,10,51,22,31,27,36,16,27,25,26,37,31,33,18,40,37,21,43,46,38,18,35,23,35,35,40,21,29,23,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,40,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,34,45,41,50,28,32,22,29,35,41,30,25,18,65,23,31,40,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,19,29,23,22,20,22,21,20,23,30,26,24,19,19,27,69,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,16,27,26,35,33,43,23,24,33,15,64,10,18,28,54,9,49,34,16,36
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,32,40,25,35,57,18,40,15,25,20,20,31,13,32,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,16,23,29,23,44,25,12,25,11,32,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,26,23,29,18,13,19,27,31,39,33,37,23,29,33,44,26,22,51,41,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,71,39,34,32,38,51,66,28,33,44,54,34,31,34,42,24,46,21,43,43,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    22,25,27,44,27,35,20,29,37,36,21,22,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,41,81,40,40,44,14,47,41,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    18,18,17,23,14,42,22,18,31,19,23,16,23,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,31,31
                                }
                            },
                            new List < Book > {
                                "I Esdras",
                                "1Esd",
                                new int[]{
                                    58,30,24,63,73,34,15,96,55
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,37,23,19,19,73,18,38,40,36,47,31
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,23,19,18,21,6,14,19,22,19,15
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,14,25
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,22,14,10,17,35,13,17,7,30,19,24,24
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,53,54,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,32,40,50,27,31,42,36,29,38,38,46,26,46,39
                                }
                            },
                            new List < Book > {
                                "III Maccabees",
                                "3Macc",
                                new int[]{
                                    29,33,30,21,51,41,23
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,13,9,9,13,11,18,10,40,8,9,6,7,6,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,6,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,19,14,9,13,12,11,14,20,8,36,37,7,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,36,45,48,43,14,31,7,10,10,9,26,18,19,2,29,176,7,8,9,4,8,5,7,5,6,8,8,3,18,3,3,21,26,9,8,24,15,10,8,12,15,22,10,11,20,14,9,6,7
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,18,26,21,27,30,22,22,35,22,20,25,28,22,35,23,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,34,24,41,35,32,34,22
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    35,23,38,28,23,40,28,37,25,33,31,31,27,36,38,33,30,24,29,30,31,31,36,77,31,29,29,30,49,35,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,20,12,30,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,17,13,14,15
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,25,19,20,24,27,30,21,19,21,27,27,19,31,19,29,21,25,22
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,31,15,37,36,19,18,31,34,18,26,27,20,30,32,33,31,32,28,27,28,34,26,29,30,26,28,40,31,26,33,31,26,31,31,35,35,30,27,27,33,24,26,20,25,25,16,29,30
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,25,5,19,15,12,16,14,17,15,12,15,16,10
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,15,17,14,15
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,15,16,20
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21,21
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    17,11,10,11
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,21
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,24
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,17,11,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,24,6
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,26,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,20,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,23,26,25,23,17,27,22,21,21,27,23,15,18,14,30,42,10,39,28,46,64,31,33,47,44,24,22,19,32,24,40,44,26,22,22,32,30,28,28,16,44,38,46,63,34
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Epistle of Jeremiah",
                                "EpJer",
                                new int[]{
                                    73
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,13,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Susanna",
                                "Sus",
                                new int[]{
                                    64
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,100,37,31,29,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Bel and the Dragon",
                                "Bel",
                                new int[]{
                                    42
                                }
                            },
                            new List < Book > {
                                "IV Maccabees",
                                "4Macc",
                                new int[]{
                                    35,24,21,26,38,35,25,29,32,21,27,20,27,20,32,25,24,24
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    52,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,41,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,26,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,14
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,9,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "segond",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,29,28,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,26,23,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,16,33,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,15,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,15,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,23,14,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,38,38,28,25,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,21,18,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,8,18,19,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,8,12,15,21,10,20,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,8,16
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    17,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,23,20,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,11,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,44,37,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,30,37,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    9,25,5,19,15,11,16,14,17,15,11,15,16,9
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,14,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    14,14,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,51,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,40,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "synodal",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,56,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,15,34,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,16,26,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,36
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,15,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,53
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    12
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "I Esdras",
                                "1Esd",
                                new int[]{
                                    58,31,24,63,70,34,15,92,55
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    22,14,17,21,22,18,17,21,6,13,18,22,18,15
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    16,28,10,15,24,21,32,36,14,23,23,20,20,19,14,25
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,35,27,26,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,39,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,26,9,10,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,7,12,15,21,10,11,9,14,9,6,7
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,29,23,35,27,36,18,32,31,28,26,35,33,33,28,25,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    16,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,24,19,20,24,27,30,21,19,21,27,28,19,31,19,29,20,25,21
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    30,18,31,35,18,37,39,22,23,34,34,18,32,27,20,31,31,33,28,31,31,31,37,37,29,27,33,30,31,27,37,25,33,26,23,29,34,39,42,32,29,26,36,27,31,23,31,28,18,31,38
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,25,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Epistle of Jeremiah",
                                "EpJer",
                                new int[]{
                                    72
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,100,34,31,28,28,27,27,21,45,13,64,42
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,12,14,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    64,70,60,61,68,63,50,32,73,89,74,53,53,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,33,40,50,27,31,42,36,29,38,38,45,26,46,39
                                }
                            },
                            new List < Book > {
                                "III Maccabees",
                                "3Macc",
                                new int[]{
                                    25,24,22,16,36,37,20
                                }
                            },
                            new List < Book > {
                                "II Esdras",
                                "2Esd",
                                new int[]{
                                    40,48,36,52,56,59,70,63,47,60,46,51,58,48,63,78
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,40,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,26,33,24
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,32,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,17,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "synodalprot",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,32,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,33,26
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,38
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,56,33,34,16,30,37,27,24,33,44,23,55,46,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,35,15,34,45,41,50,13,32,22,29,35,41,30,25,18,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,24,16,26,26,35,27,43,23,24,33,15,63,10,18,28,51,9,45,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,31,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,25
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,15,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,53
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,47,40,14,17,29,43,27,17,19,8,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,32,23,19,19,73,18,38,39,36,47,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,3
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,22,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,35,27,26,17
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,12,9,9,13,11,18,10,39,7,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,5,27,18,12,10,15,21,23,21,11,7,9,24,14,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,26,9,10,2,29,176,7,8,9,4,8,5,6,5,6,8,8,3,18,3,3,21,26,9,8,24,14,10,7,12,15,21,10,11,9,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,12,29,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    16,17,11,16,16,12,14,14
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,25,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,25,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,21,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,10,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,33,34,31,28,28,27,27,21,45,13
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,23,5,19,15,11,16,14,17,15,12,14,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,14,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,15,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    15,23
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,27,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,41,43,56,37,38,50,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,71,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,60,40,43,48,30,25,52,28,41,40,34,28,40,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,26,33,24
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,32,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,17,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                        }
                    }
                }
            }, {
                "vulg",
                new Dictionary < string,
                List < Book > [] > { {
                        "ot",
                        new List < Book > []{
                            new List < Book > {
                                "Genesis",
                                "Gen",
                                new int[]{
                                    31,25,24,26,31,22,24,22,29,32,32,20,18,24,21,16,27,33,38,18,34,24,20,67,34,35,46,22,35,43,55,32,20,31,29,43,36,30,23,23,57,38,34,34,28,34,31,22,32,25
                                }
                            },
                            new List < Book > {
                                "Exodus",
                                "Exod",
                                new int[]{
                                    22,25,22,31,23,30,25,32,35,29,10,51,22,31,27,36,16,27,25,26,36,31,33,18,40,37,21,43,46,38,18,35,23,35,35,38,29,31,43,36
                                }
                            },
                            new List < Book > {
                                "Leviticus",
                                "Lev",
                                new int[]{
                                    17,16,17,35,19,30,38,36,24,20,47,8,59,57,33,34,16,30,37,27,24,33,44,23,55,45,34
                                }
                            },
                            new List < Book > {
                                "Numbers",
                                "Num",
                                new int[]{
                                    54,34,51,49,31,27,89,26,23,36,34,15,34,45,41,50,13,32,22,30,35,41,30,25,18,65,23,31,39,17,54,42,56,29,34,13
                                }
                            },
                            new List < Book > {
                                "Deuteronomy",
                                "Deut",
                                new int[]{
                                    46,37,29,49,33,25,26,20,29,22,32,32,18,29,23,22,20,22,21,20,23,30,25,22,19,19,26,68,29,20,30,52,29,12
                                }
                            },
                            new List < Book > {
                                "Joshua",
                                "Josh",
                                new int[]{
                                    18,24,17,25,16,27,26,35,27,43,23,24,33,15,63,10,18,28,51,9,43,34,16,33
                                }
                            },
                            new List < Book > {
                                "Judges",
                                "Judg",
                                new int[]{
                                    36,23,31,24,32,40,25,35,57,18,40,15,25,20,20,31,13,31,30,48,24
                                }
                            },
                            new List < Book > {
                                "Ruth",
                                "Ruth",
                                new int[]{
                                    22,23,18,22
                                }
                            },
                            new List < Book > {
                                "I Samuel",
                                "1Sam",
                                new int[]{
                                    28,36,21,22,12,21,17,22,27,27,15,25,23,52,35,23,58,30,24,43,15,23,28,23,44,25,12,25,11,31,13
                                }
                            },
                            new List < Book > {
                                "II Samuel",
                                "2Sam",
                                new int[]{
                                    27,32,39,12,25,23,29,18,13,19,27,31,39,33,37,23,29,33,43,26,22,51,39,25
                                }
                            },
                            new List < Book > {
                                "I Kings",
                                "1Kgs",
                                new int[]{
                                    53,46,28,34,18,38,51,66,28,29,43,33,34,31,34,34,24,46,21,43,29,54
                                }
                            },
                            new List < Book > {
                                "II Kings",
                                "2Kgs",
                                new int[]{
                                    18,25,27,44,27,33,20,29,37,36,21,21,25,29,38,20,41,37,37,21,26,20,37,20,30
                                }
                            },
                            new List < Book > {
                                "I Chronicles",
                                "1Chr",
                                new int[]{
                                    54,55,24,43,26,81,40,40,44,14,46,40,14,17,29,43,27,17,19,7,30,19,32,31,31,32,34,21,30
                                }
                            },
                            new List < Book > {
                                "II Chronicles",
                                "2Chr",
                                new int[]{
                                    17,18,17,22,14,42,22,18,31,19,23,16,22,15,19,14,19,34,11,37,20,12,21,27,28,23,9,27,36,27,21,33,25,33,27,23
                                }
                            },
                            new List < Book > {
                                "Ezra",
                                "Ezra",
                                new int[]{
                                    11,70,13,24,17,22,28,36,15,44
                                }
                            },
                            new List < Book > {
                                "Nehemiah",
                                "Neh",
                                new int[]{
                                    11,20,31,23,19,19,73,18,38,39,36,46,31
                                }
                            },
                            new List < Book > {
                                "Tobit",
                                "Tob",
                                new int[]{
                                    25,23,25,23,28,22,20,24,12,13,21,22,23,17
                                }
                            },
                            new List < Book > {
                                "Judith",
                                "Jdt",
                                new int[]{
                                    12,18,15,17,29,21,25,34,19,20,21,20,31,18,15,31
                                }
                            },
                            new List < Book > {
                                "Esther",
                                "Esth",
                                new int[]{
                                    22,23,15,17,14,14,10,17,32,13,12,6,18,19,19,24
                                }
                            },
                            new List < Book > {
                                "Job",
                                "Job",
                                new int[]{
                                    22,13,26,21,27,30,21,22,35,22,20,25,28,22,35,23,16,21,29,29,34,30,17,25,6,14,23,28,25,31,40,22,33,37,16,33,24,41,35,28,25,16
                                }
                            },
                            new List < Book > {
                                "Psalms",
                                "Ps",
                                new int[]{
                                    6,13,9,10,13,11,18,10,39,8,9,6,7,5,11,15,51,15,10,14,32,6,10,22,12,14,9,11,13,25,11,22,23,28,13,40,23,14,18,14,12,6,26,18,12,10,15,21,23,21,11,7,9,24,13,12,12,18,14,9,13,12,11,14,20,8,36,37,6,24,20,28,23,11,13,21,72,13,20,17,8,19,13,14,17,7,19,53,17,16,16,5,23,11,13,12,9,9,5,8,29,22,35,45,48,43,14,31,7,10,10,9,26,9,10,2,29,176,7,8,9,4,8,5,7,5,6,8,8,3,18,3,3,21,27,9,8,24,14,10,8,12,15,21,10,11,9,14,9,6
                                }
                            },
                            new List < Book > {
                                "Proverbs",
                                "Prov",
                                new int[]{
                                    33,22,35,27,23,35,27,36,18,32,31,28,25,35,33,33,28,24,29,30,31,29,35,34,28,28,27,28,27,33,31
                                }
                            },
                            new List < Book > {
                                "Ecclesiastes",
                                "Eccl",
                                new int[]{
                                    18,26,22,17,19,11,30,17,18,20,10,14
                                }
                            },
                            new List < Book > {
                                "Song of Solomon",
                                "Song",
                                new int[]{
                                    16,17,11,16,17,12,13,14
                                }
                            },
                            new List < Book > {
                                "Wisdom",
                                "Wis",
                                new int[]{
                                    16,25,19,20,24,27,30,21,19,21,27,27,19,31,19,29,20,25,20
                                }
                            },
                            new List < Book > {
                                "Sirach",
                                "Sir",
                                new int[]{
                                    40,23,34,36,18,37,40,22,25,34,36,19,32,27,22,31,31,33,28,33,31,33,38,47,36,28,33,30,35,27,42,28,33,31,26,28,34,39,41,32,28,26,37,27,31,23,31,28,19,31,38
                                }
                            },
                            new List < Book > {
                                "Isaiah",
                                "Isa",
                                new int[]{
                                    31,22,26,6,30,13,25,22,21,34,16,6,22,32,9,14,14,7,25,6,17,25,18,23,12,21,13,29,24,33,9,20,24,17,10,22,38,22,8,31,29,25,28,28,26,13,15,22,26,11,23,15,12,17,13,12,21,14,21,22,11,12,19,12,25,24
                                }
                            },
                            new List < Book > {
                                "Jeremiah",
                                "Jer",
                                new int[]{
                                    19,37,25,31,31,30,34,22,26,25,23,17,27,22,21,21,27,23,15,18,14,30,40,10,38,24,22,17,32,24,40,44,26,22,19,32,20,28,18,16,18,22,13,30,5,28,7,47,39,46,64,34
                                }
                            },
                            new List < Book > {
                                "Lamentations",
                                "Lam",
                                new int[]{
                                    22,22,66,22,22
                                }
                            },
                            new List < Book > {
                                "Baruch",
                                "Bar",
                                new int[]{
                                    22,35,38,37,9,72
                                }
                            },
                            new List < Book > {
                                "Ezekiel",
                                "Ezek",
                                new int[]{
                                    28,9,27,17,17,14,27,18,11,22,25,28,23,23,8,63,24,32,14,49,32,31,49,27,17,21,36,26,21,26,18,32,33,31,15,38,28,23,29,49,26,20,27,31,25,24,23,35
                                }
                            },
                            new List < Book > {
                                "Daniel",
                                "Dan",
                                new int[]{
                                    21,49,100,34,31,28,28,27,27,21,45,13,65,42
                                }
                            },
                            new List < Book > {
                                "Hosea",
                                "Hos",
                                new int[]{
                                    11,24,5,19,15,11,16,14,17,15,12,14,15,10
                                }
                            },
                            new List < Book > {
                                "Joel",
                                "Joel",
                                new int[]{
                                    20,32,21
                                }
                            },
                            new List < Book > {
                                "Amos",
                                "Amos",
                                new int[]{
                                    15,16,15,13,27,15,17,14,15
                                }
                            },
                            new List < Book > {
                                "Obadiah",
                                "Obad",
                                new int[]{
                                    21
                                }
                            },
                            new List < Book > {
                                "Jonah",
                                "Jonah",
                                new int[]{
                                    16,11,10,11
                                }
                            },
                            new List < Book > {
                                "Micah",
                                "Mic",
                                new int[]{
                                    16,13,12,13,14,16,20
                                }
                            },
                            new List < Book > {
                                "Nahum",
                                "Nah",
                                new int[]{
                                    15,13,19
                                }
                            },
                            new List < Book > {
                                "Habakkuk",
                                "Hab",
                                new int[]{
                                    17,20,19
                                }
                            },
                            new List < Book > {
                                "Zephaniah",
                                "Zeph",
                                new int[]{
                                    18,15,20
                                }
                            },
                            new List < Book > {
                                "Haggai",
                                "Hag",
                                new int[]{
                                    14,24
                                }
                            },
                            new List < Book > {
                                "Zechariah",
                                "Zech",
                                new int[]{
                                    21,13,10,14,11,15,14,23,17,12,17,14,9,21
                                }
                            },
                            new List < Book > {
                                "Malachi",
                                "Mal",
                                new int[]{
                                    14,17,18,6
                                }
                            },
                            new List < Book > {
                                "I Maccabees",
                                "1Macc",
                                new int[]{
                                    67,70,60,61,68,63,50,32,73,89,74,54,54,49,41,24
                                }
                            },
                            new List < Book > {
                                "II Maccabees",
                                "2Macc",
                                new int[]{
                                    36,33,40,50,27,31,42,36,29,38,38,46,26,46,40
                                }
                            },
                        }
                    }, {
                        "nt",
                        new List < Book > []{
                            new List < Book > {
                                "Matthew",
                                "Matt",
                                new int[]{
                                    25,23,17,25,48,34,29,34,38,42,30,50,58,36,39,28,26,35,30,34,46,46,39,51,46,75,66,20
                                }
                            },
                            new List < Book > {
                                "Mark",
                                "Mark",
                                new int[]{
                                    45,28,35,40,43,56,37,39,49,52,33,44,37,72,47,20
                                }
                            },
                            new List < Book > {
                                "Luke",
                                "Luke",
                                new int[]{
                                    80,52,38,44,39,49,50,56,62,42,54,59,35,35,32,31,37,43,48,47,38,71,56,53
                                }
                            },
                            new List < Book > {
                                "John",
                                "John",
                                new int[]{
                                    51,25,36,54,47,72,53,59,41,42,57,50,38,31,27,33,26,40,42,31,25
                                }
                            },
                            new List < Book > {
                                "Acts",
                                "Acts",
                                new int[]{
                                    26,47,26,37,42,15,59,40,43,48,30,25,52,27,41,40,34,28,40,38,40,30,35,27,27,32,44,31
                                }
                            },
                            new List < Book > {
                                "Romans",
                                "Rom",
                                new int[]{
                                    32,29,31,25,21,23,25,39,33,21,36,21,14,23,33,27
                                }
                            },
                            new List < Book > {
                                "I Corinthians",
                                "1Cor",
                                new int[]{
                                    31,16,23,21,13,20,40,13,27,33,34,31,13,40,58,24
                                }
                            },
                            new List < Book > {
                                "II Corinthians",
                                "2Cor",
                                new int[]{
                                    24,17,18,18,21,18,16,24,15,18,33,21,13
                                }
                            },
                            new List < Book > {
                                "Galatians",
                                "Gal",
                                new int[]{
                                    24,21,29,31,26,18
                                }
                            },
                            new List < Book > {
                                "Ephesians",
                                "Eph",
                                new int[]{
                                    23,22,21,32,33,24
                                }
                            },
                            new List < Book > {
                                "Philippians",
                                "Phil",
                                new int[]{
                                    30,30,21,23
                                }
                            },
                            new List < Book > {
                                "Colossians",
                                "Col",
                                new int[]{
                                    29,23,25,18
                                }
                            },
                            new List < Book > {
                                "I Thessalonians",
                                "1Thess",
                                new int[]{
                                    10,20,13,18,28
                                }
                            },
                            new List < Book > {
                                "II Thessalonians",
                                "2Thess",
                                new int[]{
                                    12,17,18
                                }
                            },
                            new List < Book > {
                                "I Timothy",
                                "1Tim",
                                new int[]{
                                    20,15,16,16,25,21
                                }
                            },
                            new List < Book > {
                                "II Timothy",
                                "2Tim",
                                new int[]{
                                    18,26,17,22
                                }
                            },
                            new List < Book > {
                                "Titus",
                                "Titus",
                                new int[]{
                                    16,15,15
                                }
                            },
                            new List < Book > {
                                "Philemon",
                                "Phlm",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Hebrews",
                                "Heb",
                                new int[]{
                                    14,18,19,16,14,20,28,13,28,39,40,29,25
                                }
                            },
                            new List < Book > {
                                "James",
                                "Jas",
                                new int[]{
                                    27,26,18,17,20
                                }
                            },
                            new List < Book > {
                                "I Peter",
                                "1Pet",
                                new int[]{
                                    25,25,22,19,14
                                }
                            },
                            new List < Book > {
                                "II Peter",
                                "2Pet",
                                new int[]{
                                    21,22,18
                                }
                            },
                            new List < Book > {
                                "I John",
                                "1John",
                                new int[]{
                                    10,29,24,21,21
                                }
                            },
                            new List < Book > {
                                "II John",
                                "2John",
                                new int[]{
                                    13
                                }
                            },
                            new List < Book > {
                                "III John",
                                "3John",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "Jude",
                                "Jude",
                                new int[]{
                                    25
                                }
                            },
                            new List < Book > {
                                "Revelation of John",
                                "Rev",
                                new int[]{
                                    20,29,22,11,14,17,17,13,21,11,19,18,18,20,8,21,18,24,21,15,27,21
                                }
                            },
                            new List < Book > {
                                "Prayer of Manasses",
                                "PrMan",
                                new int[]{
                                    15
                                }
                            },
                            new List < Book > {
                                "I Esdras",
                                "1Esd",
                                new int[]{
                                    58,31,24,63,73,34,15,97,56
                                }
                            },
                            new List < Book > {
                                "II Esdras",
                                "2Esd",
                                new int[]{
                                    40,48,36,52,56,59,140,63,47,60,46,51,58,48,63,78
                                }
                            },
                            new List < Book > {
                                "Additional Psalm",
                                "AddPs",
                                new int[]{
                                    7
                                }
                            },
                            new List < Book > {
                                "Laodiceans",
                                "EpLao",
                                new int[]{
                                    20
                                }
                            },
                        }
                    }
                }
            }
        };

        public static string[] getVersifications()
        {
            return mVersificationData.Keys.ToArray();
        }

        //public int[][][] getOffsets()
        static new int[][] getTestamentOffsets(string versification, string testament)
        {
            /*
             int[] otbks = new int[]{
              0, 1, 52, 93, 121, 158,
              193, 218, 240, 245, 277, 302, 325,
              351, 381, 418, 429, 443, 454, 497,
              648, 680, 693, 702, 769, 822, 828,
              877, 890, 905, 909, 919, 921, 926,
              934, 938, 942, 946, 949, 964

              int[] otcps = new int[]{
              0, 2, 3, 35, 61, 86,
              113, 146, 169, 194, 217, 247, 280,
              313, 334, 353, 378, 400, 417, 445,
              479, 518, 537, 572, 597, 618, 686,
              721, 757, 804, 827, 863, 907, 963,...}
              
            
                offset = offsets[0][0][book_no];
                offset = offsets[0][1][offset + chap_no];
               
                }; 

            */

            List<int> bks = new List<int>();
            List<int> cps = new List<int>();

            int bks_inc = 1;
            bks.Add(0);

            int cps_inc = 2;
            cps.Add(0);
            cps.Add(2);
            string bookName = null;
            string bookAbbr = null;
            int[] chapters = new int[] { };

            foreach (var bookList in mVersificationData[versification][testament])
            {
                bks.Add(bks_inc);

                cps_inc++;
                cps.Add(cps_inc);

                //bookName = bookList[0];
                //bookAbbr = bookList[1];
                chapters = bookList[2];
                bks_inc = bks_inc + chapters.Length + 1;

                foreach (int chapter in chapters)
                {
                    cps_inc = cps_inc + chapter + 1;
                    cps.Add(cps_inc);
                }
            }
            // remove last entry
            //cps.RemoveAt(cps.Count - 1);

            return new int[][] { bks.ToArray(), cps.ToArray() };
        }


        public static int[][][] getOffsets(string versification)
        {
            return new int[][][] { getTestamentOffsets(versification, "ot"), getTestamentOffsets(versification, "nt") };
        }

        public static int getBookIndex(string versification, string bookAbbr, string testament)
        {
            string mBookAbbr = "";
            int[] mChapters = new int[] { };
            List<Book> bookList = null;

            for (int i = 0; i < mVersificationData[versification][testament].Length; i++)
            {
                bookList = mVersificationData[versification][testament][i];
                mBookAbbr = bookList[1];
                if (mBookAbbr.ToLower().Equals(bookAbbr.ToLower()))
                    return i + 1;
            }
            return -1;
        }

        public static string[] getBooks(string versification, string testament)
        {
            string mBookAbbr = "";
            int[] mChapters = new int[] { };
            List<Book> bookList = null;
            List<string> books = new List<string>();

            for (int i = 0; i < mVersificationData[versification][testament].Length; i++)
            {
                bookList = mVersificationData[versification][testament][i];
                mBookAbbr = bookList[1];
                books.Add(mBookAbbr);
            }
            return books.ToArray();
        }
    }


    enum Kind
    {
        IntArray,
        String,
    }

    class Book
    {
        int[] intArrayValue;
        string stringValue;

        Kind kind;

        public object Value
        {
            get
            {
                switch (kind)
                {
                    case Kind.IntArray:
                        return intArrayValue;
                    case Kind.String:
                        return stringValue;
                    default:
                        return null;
                }

            }
        }

        public override string ToString()
        {
            return Value.ToString();
        }

        // Implicit construction
        public static implicit operator Book(int[] i)
        {
            return new Book { intArrayValue = i, kind = Kind.IntArray };
        }
        public static implicit operator Book(string s)
        {
            return new Book { stringValue = s, kind = Kind.String };
        }

        // Implicit value reference
        public static implicit operator int[](Book Book)
        {
            if (Book.kind != Kind.IntArray) // Optionally, you could validate the usage
            {
                throw new InvalidCastException("Trying to use a " + Book.kind + " as an int[]");
            }
            return Book.intArrayValue;
        }
        public static implicit operator string(Book Book)
        {
            return Book.stringValue;
        }
    }
}
